import 'package:flutter/material.dart';
import 'dart:async';

import 'package:mm_component/mm_component.dart';

void main() {
  runApp(MaterialApp(home: MyApp()));
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String response = '';
  String mm_url = "http://172.16.116.92:8081";
  String app_version = "60";

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  Future<void> initPlatformState() async {
    await MmComponent.open(
      operation: MmComponent.KEY_NAVIGATION_LOGIN,
      version: app_version,
      url: mm_url,
      onFail: onFail,
      onSuccess: onSuccess,
      onGoto: onGoto,
      onRedirect: onRedirect,
      failAlertMode: MmComponent.MODE_TOAST,
    );
  }

  void onSuccess(String result) {
    setState(() {
      response = "onSuccess: $result";
    });
  }

  void onFail(String result) async {
    setState(() {
      response = "onFail: $result";
    });
  }

  void onGoto(String result) {
    setState(() {
      response = "onGoto: $result";
    });
  }

  void onRedirect(String result) {
    setState(() {
      response = "onRedirect: $result";
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('MM Component plugin example app'),
        ),
        body: Center(
          child: Text('Response: $response\n'),
        ),
      ),
    );
  }
}
